#ifndef __AutoSelectableSocket_h__
#define __AutoSelectableSocket_h__

#include "ISelectableSocket.h"
#include "ISelector.h"
#include "ISocket.h"
#include "T/SelectableSocketFactory.h"

class AutoSelectableSocket
{
public:
	AutoSelectableSocket( ISocket &socket, ISelector &selector, ISelectableSocket::ISocketDataHandler &socketDataHandler )
	{
		_selectableSocket = T::createSelectableSocket( socket, selector, socketDataHandler );
	}

	~AutoSelectableSocket()
	{
		T::discardSelectableSocket( _selectableSocket );
		_selectableSocket = 0;
	}

	operator ISelectableSocket &()
	{
		return *_selectableSocket;
	}

	ISelectableSocket *operator->()
	{
		return _selectableSocket;
	}

private:
	ISelectableSocket *_selectableSocket;
};

#endif // __AutoSelectableSocket_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
