#ifndef __Bitset_h__
#define __Bitset_h__

#include <algorithm>
#include <cstdio>

#include "Error.h"
#include <bitset>

template<unsigned T>
class Bitset
{
    typedef std::bitset<T> Super;
public:
    void set( unsigned index )
    {
        _container.set( index );
    }

    bool get( unsigned index ) const
    {
        return _container[index];
    }

    void clear()
    {
        _container.reset();
    }

protected:
    Super _container;
};

#endif // __Bitset_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
