#ifndef __XDialog_h__
#define __XDialog_h__

#include "ShellCommandRunner.h"

static const String XMESSAGE = "xmessage";

class XDialog
{
public:
    void addButton( const String &label, int value )
    {
        _buttons.append( Button( label, value ) );
    }

    int go( const String &text )
    {
        ShellCommandRunner shellCommandRunner( prepareCommandLine( text ) );

        int returnCode;
        String output;

        shellCommandRunner.run( returnCode, output );

        return returnCode;
    }

private:
    struct Button
    {
        Button( const String &label, int value ) : _label( label ), _value( value )
        {
        }

        String _label;
        int _value;
    };

    List<Button> _buttons;

    String prepareCommandLine( const String &text )
    {
        String result = XMESSAGE;
        result += " -center -buttons ";

        List<Button>::iterator it;

        for ( it = _buttons.begin(); it != _buttons.end(); ++it )
        {
            result += Stringf( "%s:%i,", it->_label.ascii(), it->_value );
        }

        result = result.substring( 0, result.length() - 1 );
        result += Stringf( " %s", text.ascii() );

        return result;
    }
};

#endif // __XDialog_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
