#ifndef __MockSelectableSocket_h__
#define __MockSelectableSocket_h__

#include "ConstSimpleData.h"
#include "HeapData.h"
#include "ISelectableSocket.h"
#include "ISelector.h"
#include "ISocket.h"
#include "TestLog.h"

class MockSelectableSocket : public ISelectableSocket
{
public:
	MockSelectableSocket()
	{
		wasCreated = false;
		wasDiscarded = false;

        closeWasCalled = false;
    }

	bool wasCreated;
	bool wasDiscarded;
	int lastDescriptor;
    ISocket *lastSocket;
    ISelector *lastSelector;
    ISelectableSocket::ISocketDataHandler *lastDataHandler;

	void mockConstructor( ISocket &socket, ISelector &selector, ISelectableSocket::ISocketDataHandler &socketDataHandler )
	{
		TS_ASSERT( !wasCreated );
        wasCreated = true;

		lastDescriptor = socket.descriptor();
        lastSocket = &socket;
        lastSelector = &selector;
        lastDataHandler = &socketDataHandler;
	}

	void mockDestructor()
	{
		TS_ASSERT( wasCreated );
		TS_ASSERT( !wasDiscarded );
		wasDiscarded = true;
	}

    bool closeWasCalled;

    void closeSocket()
    {
        closeWasCalled = true;
    }

    operator ISocket &()
    {
        return *lastSocket;
    }

    HeapData lastSentData;

    void send( const ConstSimpleData &data )
    {
        lastSentData = data;
    }
};

#endif // __MockSocket_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
