#ifndef __MockSelectableSocketFactory_h__
#define __MockSelectableSocketFactory_h__

#include "MockSelectableSocket.h"
#include "T/SelectableSocketFactory.h"

class MockSelectableSocketFactory :
	public T::Base_createSelectableSocket,
	public T::Base_discardSelectableSocket
{
public:
	MockSelectableSocket mockSelectableSocket;

	~MockSelectableSocketFactory()
	{
		if ( mockSelectableSocket.wasCreated )
		{
			TS_ASSERT( mockSelectableSocket.wasDiscarded );
		}
	}

	ISelectableSocket *createSelectableSocket( ISocket &socket, ISelector &selector, ISelectableSocket::ISocketDataHandler &socketDataHandler )
	{
		mockSelectableSocket.mockConstructor( socket, selector, socketDataHandler );
		return &mockSelectableSocket;
	}

	void discardSelectableSocket( ISelectableSocket *selectableSocket )
	{
		TS_ASSERT_EQUALS( selectableSocket, &mockSelectableSocket );
		mockSelectableSocket.mockDestructor();
	}
};

#endif // __MockSelectableSocketFactory_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
