#ifndef __AutoNonBlockingThreadListener_h__
#define __AutoNonBlockingThreadListener_h__

#include "INonBlockingThreadListener.h"
#include "T/NonBlockingThreadListenerFactory.h"

class AutoNonBlockingThreadListener
{
public:
	AutoNonBlockingThreadListener( ISelector &selector, IWeaver &weaver )
	{
		_nonBlockingThreadListener = T::createNonBlockingThreadListener( selector, weaver );
	}

	~AutoNonBlockingThreadListener()
	{
		T::discardNonBlockingThreadListener( _nonBlockingThreadListener );
		_nonBlockingThreadListener = 0;
	}

	operator INonBlockingThreadListener &()
	{
		return *_nonBlockingThreadListener;
	}

	INonBlockingThreadListener *operator->()
	{
		return _nonBlockingThreadListener;
	}

private:
	INonBlockingThreadListener *_nonBlockingThreadListener;
};

#endif // __AutoNonBlockingThreadListener_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
