#ifndef __AutoRegularThreadListener_h__
#define __AutoRegularThreadListener_h__

#include "IRegularThreadListener.h"
#include "T/RegularThreadListenerFactory.h"

class AutoRegularThreadListener
{
public:
	AutoRegularThreadListener( ISelector &selector, IWeaver &weaver )
	{
		_regularThreadListener = T::createRegularThreadListener( selector, weaver );
	}

	~AutoRegularThreadListener()
	{
		T::discardRegularThreadListener( _regularThreadListener );
		_regularThreadListener = 0;
	}

	operator IRegularThreadListener &()
	{
		return *_regularThreadListener;
	}

	IRegularThreadListener *operator->()
	{
		return _regularThreadListener;
	}

private:
	IRegularThreadListener *_regularThreadListener;
};

#endif // __AutoRegularThreadListener_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
