#ifndef __EventSets_h__
#define __EventSets_h__

#include "Event.h"
#include "EventPredicate.h"
#include "Vector.h"

class EventSets
{
public:
    EventSets() : _blockPredicate( NULL )
    {
    }

    EventSets( const Vector<Event> &requested,
               const Vector<Event> &blocked ) :
        _requested( requested ), _blocked( blocked ), _blockPredicate( NULL ), _blockedAsList( true )
    {
    }

    EventSets( const Vector<Event> &requested,
               EventPredicate *blockPredicate ) :
        _requested( requested ), _blockPredicate( blockPredicate ), _blockedAsList( false )
    {
    }

    EventSets &operator=( const EventSets &other )
    {
        _requested = other._requested;
        _blocked = other._blocked;
        _blockPredicate = other._blockPredicate;
        _blockedAsList = other._blockedAsList;

        return *this;
    }

    Vector<Event> _requested;
    Vector<Event> _blocked;
    EventPredicate *_blockPredicate;
    bool _blockedAsList;
};

#endif // __EventSets_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
