#ifndef __ISyncPointResolver_h__
#define __ISyncPointResolver_h__

class AtomicPropositions;
class Event;
class EventPredicate;
class IThreadListener;
class String;

#include "IServerSocket.h"
#include "Vector.h"

class ISyncPointResolver : public ISelectableSocket::ISocketDataHandler
{
public:
    virtual void go( const Vector<Event> &requested,
                     const Vector<Event> &watched,
                     const Vector<Event> &blocked,
                     unsigned timeoutInSeconds,
                     const AtomicPropositions &atomicPropositions,
                     const String &label ) = 0;

    virtual void go( const Vector<Event> &requested,
                     const Vector<Event> &watched,
                     EventPredicate *blockPredicate,
                     unsigned timeoutInSeconds,
                     const AtomicPropositions &atomicPropositions,
                     const String &label ) = 0;

    virtual Event lastEvent() const = 0;
    virtual bool done() const = 0;
    virtual bool lastEventIsTimeout() const = 0;

    virtual ~ISyncPointResolver() {}
};

#endif // __ISyncPointResolver_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
