#ifndef __T__NonBlockingThreadListenerFactory_h__
#define __T__NonBlockingThreadListenerFactory_h__

#include "cxxtest/Mock.h"

class INonBlockingThreadListener;
class ISelector;
class IWeaver;

namespace T
{
	INonBlockingThreadListener *createNonBlockingThreadListener( ISelector &selector, IWeaver &weaver );
	void discardNonBlockingThreadListener( INonBlockingThreadListener *nonBlockingThreadListener );
}

CXXTEST_SUPPLY( createNonBlockingThreadListener,
				INonBlockingThreadListener *,
				createNonBlockingThreadListener,
				( ISelector &selector, IWeaver &weaver ),
				T::createNonBlockingThreadListener,
				( selector, weaver ) );

CXXTEST_SUPPLY_VOID( discardNonBlockingThreadListener,
					 discardNonBlockingThreadListener,
					 ( INonBlockingThreadListener *nonBlockingThreadListener ),
					 T::discardNonBlockingThreadListener,
					 ( nonBlockingThreadListener ) );

#endif // __T__NonBlockingThreadListenerFactory_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
