#ifndef __T__SyncPointResolverFactory_h__
#define __T__SyncPointResolverFactory_h__

#include "cxxtest/Mock.h"

class ISelector;
class ISocket;
class ISyncPointResolver;

namespace T
{
	ISyncPointResolver *createSyncPointResolver( ISelector &selector, ISocket &socket );
	void discardSyncPointResolver( ISyncPointResolver *syncPointResolver );
}

CXXTEST_SUPPLY( createSyncPointResolver,
				ISyncPointResolver *,
				createSyncPointResolver,
				( ISelector &selector, ISocket &socket ),
				T::createSyncPointResolver,
				( selector, socket ) );

CXXTEST_SUPPLY_VOID( discardSyncPointResolver,
					 discardSyncPointResolver,
					 ( ISyncPointResolver *syncPointResolver ),
					 T::discardSyncPointResolver,
					 ( syncPointResolver ) );

#endif // __T__SyncPointResolverFactory_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
