#ifndef __MockNonBlockingThreadListener_h__
#define __MockNonBlockingThreadListener_h__

#include "INonBlockingThreadListener.h"
#include "TestLog.h"

class MockNonBlockingThreadListener : public INonBlockingThreadListener
{
public:
	MockNonBlockingThreadListener()
	{
		wasCreated = false;
		wasDiscarded = false;
    }

	bool wasCreated;
	bool wasDiscarded;

    ISelector *lastSelector;
    IWeaver *lastWeaver;

	void mockConstructor( ISelector &selector, IWeaver &weaver )
	{
		TS_ASSERT( !wasCreated );
		wasCreated = true;

        lastSelector = &selector;
        lastWeaver = &weaver;
    }

	void mockDestructor()
	{
		TS_ASSERT( wasCreated );
		TS_ASSERT( !wasDiscarded );
		wasDiscarded = true;
	}

    void handleAcceptedSocket( ISocket &// socket
                               )
    {
    }
};

#endif // __MockNonBlockingThreadListener_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
