#ifndef __MockSyncPointResolverFactory_h__
#define __MockSyncPointResolverFactory_h__

#include "MockSyncPointResolver.h"
#include "T/SyncPointResolverFactory.h"

class MockSyncPointResolverFactory :
	public T::Base_createSyncPointResolver,
	public T::Base_discardSyncPointResolver
{
public:
	MockSyncPointResolver mockSyncPointResolver;

	~MockSyncPointResolverFactory()
	{
		if ( mockSyncPointResolver.wasCreated )
		{
			TS_ASSERT( mockSyncPointResolver.wasDiscarded );
		}
	}

	ISyncPointResolver *createSyncPointResolver( ISelector &selector, ISocket &socket )
	{
		mockSyncPointResolver.mockConstructor( selector, socket );
		return &mockSyncPointResolver;
	}

	void discardSyncPointResolver( ISyncPointResolver *syncPointResolver )
	{
		TS_ASSERT_EQUALS( syncPointResolver, &mockSyncPointResolver );
		mockSyncPointResolver.mockDestructor();
	}
};

#endif // __MockSyncPointResolverFactory_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
