#ifndef __AckNumberPayload_h__
#define __AckNumberPayload_h__

#include "ConstSimpleData.h"
#include <string.h>

struct AckNumberPayload
{
public:
    AckNumberPayload( unsigned ackNumber ) : _ackNumber( ackNumber )
    {
    }

    AckNumberPayload( const ConstSimpleData &payload )
    {
        memcpy( this, payload.data(), sizeof(AckNumberPayload) );
    }

    unsigned getAckNumber() const
    {
        return _ackNumber;
    }

private:
    unsigned _ackNumber;
} __attribute((packed));

#endif // __AckNumberPayload_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
