#ifndef __ConnectionIdentifier_h__
#define __ConnectionIdentifier_h__

struct ConnectionIdentifier
{
    ConnectionIdentifier() : _ip( 0 ), _port( 0 )
    {
    }

    ConnectionIdentifier( const String &ip, unsigned short port ) : _port( port )
    {
        struct in_addr ipAddress;
        memset( &ipAddress, 0, sizeof(ipAddress) );

        inet_aton( ip.ascii(), &ipAddress );
        _ip = htonl( ipAddress.s_addr );
    }

    bool operator==( const ConnectionIdentifier &other ) const
    {
        return ( _ip == other._ip ) && ( _port == other._port );
    }

    bool operator!=( const ConnectionIdentifier &other ) const
    {
        return !( *this ==  other );
    }

    bool operator<( const ConnectionIdentifier &other ) const
    {
        if ( _ip < other._ip )
        {
            return true;
        }

        if ( ( _ip == other._ip ) && ( _port < other._port ) )
        {
            return true;
        }

        return false;
    }

    String ipAsString() const
    {
        struct in_addr ip_addr;
        memset( &ip_addr, 0, sizeof(ip_addr) );
        ip_addr.s_addr = ntohl( _ip );
        return inet_ntoa( ip_addr );
    }

    unsigned _ip;
    unsigned short _port;
} __attribute((packed));

#endif // __ConnectionIdentifier_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
