#ifndef __OccasionalRetransmitPolicy_h__
#define __OccasionalRetransmitPolicy_h__

#include "ServerPolicy.h"

class OccasionalRetransmitPolicy : public ServerPolicy
{
public:
    OccasionalRetransmitPolicy() : _counter( 0 )
    {
    }

    enum {
        WHEN_TO_BLOCK = 3
    };

    bool shouldAllowPacket( TcpSegment &tcpSegment )
    {
        if ( !tcpSegment.header().getPush() )
        {
            return true;
        }

        ++_counter;

        if ( _counter == WHEN_TO_BLOCK )
        {
            _counter = 0;
            return false;
        }

        return true;
    }

private:
    unsigned _counter;

};

#endif // __OccasionalRetransmitPolicy_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
